/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
*  Copyright 2013 - 2020, nymea GmbH
*  Contact: contact@nymea.io
*
*  This file is part of nymea.
*  This project including source code and documentation is protected by copyright law, and
*  remains the property of nymea GmbH. All rights, including reproduction, publication,
*  editing and translation, are reserved. The use of this project is subject to the terms of a
*  license agreement to be concluded with nymea GmbH in accordance with the terms
*  of use of nymea GmbH, available under https://nymea.io/license
*
*  GNU General Public License Usage
*  Alternatively, this project may be redistributed and/or modified under
*  the terms of the GNU General Public License as published by the Free Software Foundation,
*  GNU version 3. this project is distributed in the hope that it will be useful, but WITHOUT ANY
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
*  PURPOSE. See the GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License along with this project.
*  If not, see <https://www.gnu.org/licenses/>.
*
*  For any further details and any questions please contact us under contact@nymea.io
*  or see our FAQ/Licensing Information on https://nymea.io/license/faq
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef USERINFORMATION_H
#define USERINFORMATION_H

#include <QDebug>
#include <QString>

namespace remoteproxy {


class UserInformation
{
public:
    UserInformation(const QString &email = QString(), const QString &cognitoUsername  = QString(), const QString &vendorId = QString(), const QString &userPoolId = QString());

    QString email() const;
    QString cognitoUsername() const;
    QString vendorId() const;
    QString userPoolId() const;

    bool isValid();

private:
    QString m_email;
    QString m_cognitoUsername;
    QString m_vendorId;
    QString m_userPoolId;
};

QDebug operator<<(QDebug debug, const UserInformation &userInformation);

}

#endif // USERINFORMATION_H
